
# 1.6.0
-  (Feature) Frontpage now detects if user is logged in
    -  If user is logged in, the frontpage will show a user's books button instead of login
-  (Feature) Added an indicator for the currently online users
    -  The indicator is shown in the sidebar on the right side of each page preview if another user is currently viewing the page
    -  On hover it shows the email of the user
-  (Feature) Profile page has some functionality now
    -  User may change their email (requires email verification)
    -  User may change their password (requires email verification)
    -  User may set the default values for the different tools
-  (Feature) Bye Bye ugly navbar
    - Opted to remove the global navbar as it only showed duplicate information
    - The sidebar should now be used for the main navigation
-  (Feature) Clicking on the header of an snip now gives more information about the snip
    -  This includes: snip type, width, height and creation date
-  (Feature) Text tool now has an alignment submenu item
    -  Allows to align snippet to top, center, bottom, left, center, right of page
-  (Feature) Image placement tool now has an alignment submenu item
    -  Allows to align snippet to top, center, bottom, left, center, right of page
-  (Feature) The page move tool now has auto fit width and height buttons
    -  This will automatically fit the page to the width or height of your screen
-  (Feature) Users are now notified on bad connections
-  (Dev) We now partially use app router instead of pages router
    - smaller bundle size
    - faster page transitions
-  (Dev) Split up codebase into multiple independent packages
    - allows for easier testing
    - allows for easier development
    - this is a quite significant change!
-  (Dev) Added validation for env parameters
    - catch missing env parameters early!
-  (Dev) Added BackgroundTypes database service
-  (Dev) Added dedicated server for email sending 
-  (Dev) Maintenance page handler, if the app is down you will know now
-  (Fix) Fixed canvas render width/height issue on devices with devicePixelRatio!=1
    - see [#74](https://gitlab.gwdg.de/irp/snip/-/issues/74)
-  (Fix) Verify/Reset Password emails look a bit better now (css added)
-  (Fix) Gird view overflow on long book names now shows as ellipsis
-  (Fix) Sometimes the page flickered on resize this was because the page was resized before canvas

# 1.5.3
-  (Dev) Refactor email functions
-  (Dev) Graceful quit for prebuild script
-  (Dev) Upgraded from buster to bookworm docker image
-  (Fix) Fixed a bug in the server side render pipeline (textBaseline was wrong)
    -  see https://github.com/Automattic/node-canvas/issues/2343

# 1.5.2
-   (Fix) Unauthorized screen layout was broken
-   (Dev) Refactor upload endpoint
-   (Fix) Updated API Usage docs
    - updated example scripts for upload
-   (Feature) Test mode for testing uploads

# 1.5.1
-   (Feature) Page search in viewer is now fully functional
    -   Search is case insensitive
    -   Allows for modifiers (snip types, page numbers, etc.)
    -   see docs for more info
-   (Fix) Reset password screen alignment was broken
-   (Fix) Verify email screen alignment was broken
-   (Fix) Overflow was always shown in chrome this yielded a white line at the bottom of the page

# 1.5.0
-   (Feature) Added interaction mode (small eye icon)
    - allows to copy and past texts
    - allows to interact with snips which have event handlers
        - e.g. on_click
        - at the moment there are no snips with feedback but the framework is there
-   (Dev) Refactor of overlay modules (related to above)
-   (Dev) Text edit tool uses the new overlay modules


# 1.4.4
-   (Dev) Refactor of tools to reduce some code duplication
-   (Docs) Split the developer docs into deployment and developer guides
    -  Also fixes some old docs, where things just changed
    -  Added to developer guides
        -  snip documentation
        -  tool documentation
    - Parsing of links was broken if they ended with `.md` or `.mdx`
-   (Deployment) Docker entrypoint now automatically checks for database migration

# 1.4.3

-   (Fix) Fixed bug with draw interpolation
    -   On canvas leave the line would be drawn to left top corner because of inserting null values
    -   Do not draw null values
-   (Fix) Logout not handled gracefully

# 1.4.2

-   (Fix) Strange scroll behavior in edit page
-   (Features) Read only mode
    -   tools are dynamically picked by access level
    -   see new field in /book/:id/edit/access
-   (Fix) Fixed a bug where the snips to place where not updated when a user adds a new snip
-   (Fix) Overlay sometimes persisted on page change
-   (Feature) Reenabled old live updates for drawing (might be disabled again depending on performance)

# 1.4.1

-   (Fix) Fixed some alignment problems with the frontpage on mobile devices
-   (Feature) Added pointer events instead of mouse events
    -   This should fix some problems with touch devices
    -   This applies to the resizer, move tool, draw tool and text tool

# 1.4.0

-   (Feature) We have a frontpage now! It explains the features of the app and helps new users get started.
-   (Feature) Pen line smoothing #28
    -   New Slider to adjust smoothing
    -   Ramer-Douglas-Peucker algorithms for simplification of the polyline with additional splines for drawing.
-   (Feature) User settings #29
    -   Settings are saved for each user in the database
    -   Settings are synced across devices
        -   This only happens on page reload or focus change as everything else is confusing if using multiple tabs
    -   Settings include:
        -   Zoom level(s)
        -   Font, Font size, Line height, Line Wrap
        -   Pen color, pen size
-   (Feature) Added background gradient to page viewer
-   (Fix) Fixed a bug where the page was setup multiple times by the worker
-   (Dev) Fonts are now dynamically injected into the page
    -   This makes the process of adding fonts much easier
    -   Has no effect on the user

# 1.3.4

-   (Fix) Chrome range slider looked different than other browsers
-   (Fix) Zoom rounding error #61
-   (Fix) Tab change sometimes produced an empty page i.e. force rerender on activity change

# 1.3.3

-   (Feature) Added modal to configure pdf download
    -   Option to download with page numbers
    -   Option to only download selected pages
-   (Fix) Adjusted styling of page number in sidebar of book viewer
-   (Fix) Fixed bug with resizer using manual input or mouse wheel #61
-   (Fix) Show finished books by default #60
-   (Fix) Fixed tool not changing anymore in textarea on typing "p" or "m" #56

# 1.3.2

-   (Feature) New book browser
    -   Folder sorting
        -   Drag and drop to sort folders
    -   Book sorting
        -   Sort by title, last modified, date added, and num pages

# 1.3.1

-   (Feature) Image compression
    -   Added script to compress all images, see `scripts` folder
    -   Added auto image compression for file uploads
    -   WebP support for images
-   (Feature) Added maintenance mode
    -   Redirects all requests to maintenance.html page
    -   Started by putting COMMAND=maintenance in .env file
