import { NextFunction, Request, Response } from "express";

import { getSession } from "@snip/auth/session";

// Auth middleware
export async function authMiddleWare(
    req: Request,
    res: Response,
    next: NextFunction,
) {
    const session = await getSession(req, res);
    if (!session || (!session.user_api && !session.user_id)) {
        res.status(401).json({
            error: "Unauthorized",
        });
        return;
    }
    req.session = session;
    next();
}
