"use client";
import { useEffect, useState } from "react";
import { Button } from "react-bootstrap";

import { PageWorker } from "components/editor/worker/pageWorker";
import { TextInput } from "components/form/inputs/text";
export function RequestPage() {
    return (
        <form
            action={(formData: FormData) => {
                const page_id = formData.get("page") as string;
                if (page_id && !isNaN(parseInt(page_id))) {
                    // go to thispage?page=page_id
                    window.location.href = `/debug/render?page=${page_id}`;
                }
            }}
        >
            Select page to render:
            <TextInput
                label="Page id"
                name="page"
                placeholder="Page id"
                more={
                    <SubmitButton className="btn btn-primary">
                        Render
                    </SubmitButton>
                }
            />
        </form>
    );
}

export function Client({ book, page }) {
    const [worker, setWorker] = useState<PageWorker>(null);
    useEffect(() => {
        if (!worker) {
            setWorker(new PageWorker());
        }
    }, [worker]);

    if (!page || !book) {
        return null;
    }

    return (
        <div className="d-flex flex-column gap-3">
            <Canvas
                className="border border-primary rounded"
                id="main"
                worker={worker}
                pageData={page}
                width={720}
                height={1028}
            />
            <Button
                variant="primary"
                onClick={async () => {
                    await worker.rerender();
                }}
            >
                Rerender
            </Button>
        </div>
    );
}
