import { exec } from "child_process";

export async function setupDatabase() {
    // Check if container is running

    await execute("docker compose up -d");
    // Wait for 2 seconds to allow the database to start
    await new Promise((resolve) => setTimeout(resolve, 2000));

    // Wait for the migration container to finish
    await execute("docker wait test_migration");

    // Await delete of all data
}

export async function teardownDatabase() {
    // Stop your Docker containers or any other teardown logic
    await execute("docker compose down");
}

const execute = async (string: string) => {
    await new Promise((resolve, reject) => {
        exec(
            string,
            { cwd: __dirname + "/docker" },
            (error, stdout: string, stderr: string) => {
                if (error) {
                    console.error(stderr);
                    reject(error);
                } else {
                    resolve(stdout);
                }
            }
        );
    });
};
